<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}
if(!class_exists('Wplms_Wlm_Class'))
{   

    class Wplms_Wlm_Class // We'll use this just to avoid function name conflicts 
    {
        public static $instance;
        public static function init(){
            if ( is_null( self::$instance ) )
                self::$instance = new Wplms_Wlm_Class();
            return self::$instance;
        }   
        public function __construct(){ 
            //settings added and saved 
            add_action('wplms_course_metabox',array($this,'add_wcm_membership_settings_backend'));

            //Display pricing
            //add_filter('wplms_course_credits_array',array($this,'course_wcm_link'),999,2);
           // add_filter('wplms_course_product_id',array($this,'course_wcm_link_pid'),10,2);
            //Select membership levle in pricing front end
            add_filter('wplms_course_creation_tabs',array($this,'add_wcm_membership_settings_frontend'));
            //FallBack to award Courses when user has membership
            add_action('wplms_the_course_button',array($this,'provide_access_course_button'),10,2);


            add_action('wishlistmember_remove_user_levels',array($this,'remove_user_from_courses'),10,2);
            add_action('wishlistmember_unapprove_user_levels',array($this,'remove_user_from_courses'),10,2);
            add_action('wishlistmember_unconfirm_user_levels',array($this,'remove_user_from_courses'),10,2);
            add_action('wishlistmember_cancel_user_levels',array($this,'remove_user_from_courses'),10,2);



            add_action('wishlistmember_add_user_levels',array($this,'add_user_to_levels'),10,2);
            add_action('wishlistmember_approve_user_levels',array($this,'add_user_to_levels'),10,2);
            add_action('wishlistmember_confirm_user_levels',array($this,'add_user_to_levels'),10,2);
            add_action('wishlistmember_uncancel_user_levels',array($this,'add_user_to_levels'),10,2);

        } // END public function __construct

        function activate(){
            // ADD Custom Code which you want to run when the plugin is activated
        }
        function deactivate(){
            // ADD Custom Code which you want to run when the plugin is de-activated    
        }



        function remove_user_from_courses($user_id,$levels){
             global $wpdb;
            foreach ($levels as $key => $membership_id) {
                $courses =$wpdb->get_results($wpdb->prepare("SELECT post_id as course_id  FROM {$wpdb->postmeta} WHERE meta_key ='%s' AND meta_value LIKE '%s'",'vibe_wlm_plans','%"'.$membership_id.'"%'));

                if(!empty($courses)){
                    foreach($courses as $course){
                        
                        $metas = get_post_meta($course->course_id,'vibe_wlm_plans',true);
                        $obj = new WLMAPIMethods();
                        $_user_membership_ids = $obj->get_member_levels($user_id,true);
                         $user_membership_ids = array();
                         if(!empty( $_user_membership_ids)){
                            foreach ( $_user_membership_ids as $key => $value) {
                                if(!empty($value->Active)){
                                    $user_membership_ids[] = $key;
                                }
                            }
                         }
                        if(!empty($metas)){
                            $result = array_diff($metas, $user_membership_ids);
                            if(count($metas) == count($result)){
                                //unsubscribe from course
                                bp_course_remove_user_from_course($user_id,$course->course_id);
                            }
                        }
                    }
                }
            }
            
        }

        function add_user_to_levels($user_id,$levels){
             global $wpdb;
            foreach ($levels as $key => $membership_id) {

                $courses =$wpdb->get_results($wpdb->prepare("SELECT post_id as course_id  FROM {$wpdb->postmeta} WHERE meta_key ='%s' AND meta_value LIKE '%s'",'vibe_wlm_plans','%"'.$membership_id.'"%'));

                if(!empty($courses)){
                    foreach($courses as $course){
                        //unsubscribe from course
                        if(!wplms_user_course_active_check($user_id ,$course->course_id )){
                            bp_course_add_user_to_course($user_id,$course->course_id);
                        }
                    }
                }
            }
        }

        function provide_access_course_button($course_id,$user_id){
            if(!is_user_logged_in())
                return;
            if(wplms_user_course_active_check($user_id ,$course_id ))
                return;
            $membership_plans = get_post_meta($course_id,'vibe_wlm_plans',true);

            if(!empty($membership_plans) && is_array($membership_plans) && class_exists('WLMAPIMethods')){
                $obj = new WLMAPIMethods();
                foreach($membership_plans as $membership_plan){
                    //Check if user is a member of the membership and it is Active
                    if($obj->is_user_a_member($membership_plan, $user_id)){

                        if(!wplms_user_course_active_check($user_id ,$course_id )){

                            
                            bp_course_add_user_to_course($user_id,$course_id );
                            break;
                        }
                    }
                     
                }
            }
        }

        function course_wcm_link($credits,$course_id){
            $memberships = get_post_meta($course_id,'vibe_wlm_plans',true);
            if(!empty($memberships) && is_array($memberships)){
                 $link ='';

                foreach($memberships as $membership){
                    $product_id  = get_post_meta($membership,'wplms_course_primary_product',true);
                    if(!empty($product_id)){
                       if(function_exists('icl_object_id'))
                            $product_id = icl_object_id($product_id[0], 'page', true);
                        $link = get_permalink($product_id[0]);
                        
                        $credits[$link] = '<strong>'.get_the_title($membership).'</strong>';  
                    }
                }
            }
            return $credits;
        }

        function add_wcm_membership_settings_frontend($settings){
            if(class_exists('WLMAPIMethods')){
                $obj= new WLMAPIMethods();
                
                $_plans = $obj->get_levels(true);
                if(!empty($_plans) && !empty($_plans['levels']['level']) && count($_plans['levels']['level'])){
                    $palns = array();
                    foreach($_plans['levels']['level'] as $wcm_plan){
                        $plans[] = array('value'=>$wcm_plan['id'],'label' => $wcm_plan['name']);
                    }

                
                    $fields = $settings['course_pricing']['fields'];
                    $arr=array(array(
                                'label' => __('Wishlist memberships','wplms-wlm'), // <label>
                                'desc'  => __('Select wishlist membership levels here','wplms-wlm'), 
                                'text'=>__('Wishlist memberships','wplms-wlm' ),// description
                                'id'  => 'vibe_wlm_plans', // field id and name
                                'type'  => 'multiselect', // type of field
                                'options'   => $plans
                                ));

                    array_splice($fields, (count($fields)-1), 0,$arr );
                    $settings['course_pricing']['fields'] = $fields;  
                }
            }
            return $settings;
        }

        function course_wcm_link_pid($pid,$course_id){
           if(!is_numeric($pid)){
                $memberships = get_post_meta($course_id,'vibe_wlm_plans',true);
                if(!empty($memberships) && is_array($memberships)){
                    foreach($memberships as $membership){
                        $product_id  = get_post_meta($membership,'wplms_course_primary_product',true);
                        if(!empty($product_id)){
                           if(function_exists('icl_object_id'))
                                $product_id = icl_object_id($product_id[0], 'page', true);
                            $pid = get_permalink($product_id[0]);
                            break;
                        }
                    } 
                }
           }
           return $pid;
        }

        function add_wcm_membership_settings_backend($settings){
            if(class_exists('WLMAPIMethods')){
                $obj= new WLMAPIMethods();
             
                $_plans = $obj->get_levels(true);
                if(!empty($_plans) && !empty($_plans['levels']['level']) && count($_plans['levels']['level'])){
                        $palns = array();
                        foreach($_plans['levels']['level'] as $wcm_plan){
                            $plans[] = array('value'=>$wcm_plan['id'],'label' => $wcm_plan['name']);
                        }
                    $settings['vibe_wlm_plans'] = array(
                        'label' => __('Wishlist memberships','wplms-wlm'), // <label>
                        'desc'  => __('Select wishlist membership levels here','wplms-wlm'), // description
                        'id'    => 'vibe_wlm_plans', // field id and name
                        'type'  => 'multiselect', // type of field
                        'options' => $plans,
                    );
                }
            }
            return $settings;
        }

        

    } // END class Wplms_Wlm_Class
} // END if(!class_exists('Wplms_Wlm_Class'))

